*
      SUBROUTINE PAZ_HEEVZ(NAME, N, NPROCS, MMIN, NB, NPROW, NPCOL)
*
*        NB,   (NPROW,NPCOL)  
*          
*     PZHEEV2, PZHEEV4, PZHEEV6
*
*  
      INTEGER           N, NPROCS, MMIN, NB, NPROW, NPCOL
      CHARACTER*(*)     NAME, TRANS
*
*   -  
      INTEGER           NPR
      PARAMETER         (NPR = 6, TRANS='N')
*
*  
      INTEGER           ANB, CTXT, I, IAM, INFO, IPA, IPEV, IPGAP,
     $                  IPFAIL, IPCLUSTR, IPW, IPWOR, IPIWOR, IPRWOR,
     $                  IPZ, NP00, NP0, NQ00, NQ0, M, MQ0, MXLLDA,
     $                  MXLLDZ, MYCOL, MYROW, MXNP, MXNQ, NEIG, NN, NZ,
     $                  NRC0, LWOPT, LWORK, LIWORK, LRWORK, IA,JA,
     $                  IZ,JZ, NPS, NSYTRD, NHETRD_LWOPT, SQNPC,
     $                  SIZEPZHETRD, SIZEPZUNMTR, SIZEZSTEQR2, LRWMIN,
     $                  NPROCS1, LCM, LCMQ, NQB, NB0, SIZESYTRD, LWMIN
     $                  WORKSIZ
*
*  
      INTEGER           ICEIL, NUMROC
      EXTERNAL          ICEIL, NUMROC
*
*  
      INTRINSIC         ABS, DBLE, MAX, MIN, MOD, SQRT, INT
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = INT(SQRT(REAL(NPROCS)))
      NPCOL = NPROCS/NPROW
*
      NB0 = INT(REAL( N/MAX(NPROW,NPCOL) ))
      IF( NB0.LT.4 ) NB = 2
*1      NB0 = INT(REAL( N/NPROW) )
*1      IF( NB0.LT.4 ) NB = NB0
      IF( NB0.GE.4 .AND. NB0.LT.8 ) NB = 4
*
      IF( NB0.GE.8 .AND. NB0.LT.16 ) NB = 8
      IF( NB0.GE.16 .AND. NB0.LT.32 ) NB = 16
      IF( NB0.GE.32 ) NB = 32
*
*      IA = 1, JA = 1, IZ = 1, JZ = 1
*
      MXNP = NUMROC( N, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      MXLLDA = MXNP
*
*     A
      IPA = 1
*     EV ( )
      IPEV = IPA + MXLLDA*MXNQ
*
      IF( NAME .NE. 'PZHEEV4' .AND. NAME .NE. 'PZHEEV6' ) GOTO 2
*
      IPGAP = IPEV + N
      IPFAIL = IPGAP + NPROW*NPCOL
      IPCLUSTR = IPFAIL + N
*    (*2 ?)  Z (  )
      IPZ = IPCLUSTR + NPROW*NPCOL
*     WORK
      MXLLDZ = MXLLDA
      IPWOR = IPZ + MXLLDZ*MXNQ
*
*   ,    PZHEEV4(6)
*
      NP0 = NUMROC( N, NB, 0, 0, NPROW )
      MQ0 = NUMROC( N, NB, 0, 0, NPCOL )
*
      NN = MAX( N, NB, 2 )
*
      NEIG = N
      IF( NAME .NE. 'PZHEEV6' ) GOTO 1
*
       NEIG = IU - IL + 1
*
    1  MQ0 = NUMROC( MAX( NEIG, NB, 2 ), NB, 0, 0, NPCOL )
       NQ0 = NUMROC( NN, NB, 0, 0, NPCOL )
       LWMIN = N + ( NP0+NQ0+NB )*NB
       LRWMIN = 4*N + MAX( 5*NN, NP0*MQ0 ) +
     $ ICEIL( NEIG, NPROW*NPCOL )*NN
       LRWOPT = LRWMIN
       LWOPT = LWMIN
*
      ANB = 16
      SQNPC = INT( SQRT( DBLE( NPROW*NPCOL ) ) )
      NPS = MAX( NUMROC( N, 1, 0, 0, SQNPC ), 2*ANB )
      NHETRD_LWOPT = 2*( ANB+1 )*( 4*NPS+2 ) + ( NPS+2 )*NPS
      LWOPT = MAX( LWOPT, N + NHETRD_LWOPT )
*
      LWORK = LWOPT
      LRWORK = LRWMIN
      LIWORK = 6*MAX( N, NPROCS+1, 4 )
*
*     RWORK, IWORK
      IPRWOR = IPWOR + LWORK
      IPIWOR = IPRWOR + LRWORK
      IPW = IPIWOR + LIWORK
*
      GOTO 3
*
    2 IF( NAME .NE. 'PZHEEV2' ) GOTO 10
*
*   ,    PZHEEV2
*
*     Z (  )
      IPZ = IPEV + N
*     WORK
      IPWOR = IPZ + MXNP*MXNQ
*
      SIZEPZHETRD =  MAX( (MXNP+1)*NB, 3*NB )
*
      NQ00 = NUMROC( N, NB, 0, 0, NPCOL )
      NP00 = NUMROC( N-1, NB, 0, 0, NPROW )
*
      SIZEPZUNMTR = MAX(( NB*(NB - 1) )/2, (NQ00 + NP00)*NB) + NB*NB
*
      RSIZEZSTEQR2 = MIN( 1, 2*N-2 )
*
      LDC = 0
      NRC0 = NUMROC( N, NB, 0, 0, NPROCS)
      LDC = MAX( 1, NRC0 )
*
      SIZEZSTEQR2 = N*LDC
*
      LRWORK = 2*N + RSIZEZSTEQR2
      LWORK = 3*N + MAX( SIZEPZHETRD, SIZEPZUNMTR, SIZEZSTEQR2 )
*
      IPRWOR = IPWOR + LWORK
      IPW = IPRWOR + LRWORK
*
      GOTO 3
*
*     PZLAPRNT  .
*
    3 WORKSIZ = MAX( NB, MXNP )
*
*        
*
      MMIN = IPW + WORKSIZ
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = 9992 )NAME
        WRITE( NPR, FMT = 9998 )N, N, NPROCS
        WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
        WRITE( NPR, FMT = 9993 )NB, NB
        WRITE( NPR, FMT = * )'IPEV IPZ IPWOR IPRWOR IPW  MMIN'
        WRITE( NPR, FMT = 9994 )IPEV, IPZ, IPWOR, IPRWOR, IPW, MMIN
*
        IF( NAME .NE. 'PZHEEV4' .AND. NAME .NE. 'PZHEEV6' ) GOTO 4
        WRITE( NPR, FMT = * )'IPGAP IPFAIL  IPCLUSTR '
        WRITE( NPR, FMT = 9994 ) IPGAP, IPFAIL, IPCLUSTR
        WRITE( NPR, FMT = * )' IPZ  ANB  NPS LWORK LIWORK LRWORK'
        WRITE( NPR, FMT = 9994 ) IPZ, ANB, NPS, LWORK, LIWORK, LRWORK
        GOTO 5
    4   WRITE( NPR, FMT = * )' NRC0 LDC'
        WRITE( NPR, FMT = 9994 ) NRC0, LDC
*
    5   CONTINUE
      END IF
*
 9994 FORMAT( / 7I5 /)
*
   10 CONTINUE
*
 9992 FORMAT( / '    ',
     $      '       ', A7/ )
*
 9998 FORMAT( /'      A ',I2,' *',I2,',',
     $       '    ',I2 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'     '/)
 9993 FORMAT( / '       NB ',
     $       I2,' *',I2 // '     '/)
      STOP
      END
